diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-tx-vector.h ns-3.38/src/wifi/model/wifi-tx-vector.h
--- ns-3.37/src/wifi/model/wifi-tx-vector.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-tx-vector.h	2023-03-16 20:54:23.868869300 -0700
@@ -36,7 +36,7 @@
 struct HeMuUserInfo
 {
     HeRu::RuSpec ru; ///< RU specification
-    WifiMode mcs;    ///< MCS
+    uint8_t mcs;     ///< MCS index
     uint8_t nss;     ///< number of spatial streams
 
     /**
@@ -100,7 +100,7 @@
 class WifiTxVector
 {
   public:
-    /// map of HE MU specific user info paramters indexed by STA-ID
+    /// map of HE MU specific user info parameters indexed by STA-ID
     typedef std::map<uint16_t /* staId */, HeMuUserInfo /* HE MU specific user info */>
         HeMuUserInfoMap;
 
@@ -122,6 +122,7 @@
      * \param ldpc enable or disable LDPC (BCC is used otherwise)
      * \param bssColor the BSS color
      * \param length the LENGTH field of the L-SIG
+     * \param triggerResponding the Trigger Responding parameter
      */
     WifiTxVector(WifiMode mode,
                  uint8_t powerLevel,
@@ -135,7 +136,8 @@
                  bool stbc = false,
                  bool ldpc = false,
                  uint8_t bssColor = 0,
-                 uint16_t length = 0);
+                 uint16_t length = 0,
+                 bool triggerResponding = false);
     /**
      * Copy constructor
      * \param txVector the TXVECTOR to copy
@@ -267,13 +269,13 @@
     /**
      * Checks whether the PSDU contains A-MPDU.
      * \returns true if this PSDU has A-MPDU aggregation,
-     *          false otherwise.
+     *          false otherwise
      */
     bool IsAggregation() const;
     /**
      * Sets if PSDU contains A-MPDU.
      *
-     * \param aggregation whether the PSDU contains A-MPDU or not.
+     * \param aggregation whether the PSDU contains A-MPDU or not
      */
     void SetAggregation(bool aggregation);
     /**
@@ -303,6 +305,12 @@
      */
     void SetLdpc(bool ldpc);
     /**
+     * Checks whether this TXVECTOR corresponds to a non-HT duplicate.
+     * \returns true if this TXVECTOR corresponds to a non-HT duplicate,
+     *          false otherwise.
+     */
+    bool IsNonHtDuplicate() const;
+    /**
      * Set the BSS color
      * \param color the BSS color
      */
@@ -323,6 +331,16 @@
      */
     uint16_t GetLength() const;
     /**
+     * Return true if the Trigger Responding parameter is set to true, false otherwise.
+     * \return true if the Trigger Responding parameter is set to true, false otherwise
+     */
+    bool IsTriggerResponding() const;
+    /**
+     * Set the Trigger Responding parameter to the given value
+     * \param triggerResponding the value for the Trigger Responding parameter
+     */
+    void SetTriggerResponding(bool triggerResponding);
+    /**
      * The standard disallows certain combinations of WifiMode, number of
      * spatial streams, and channel widths.  This method can be used to
      * check whether this WifiTxVector contains an invalid combination.
@@ -331,21 +349,17 @@
      */
     bool IsValid() const;
     /**
-     * Return true if this TX vector is used for a multi-user transmission.
-     *
-     * \return true if this TX vector is used for a multi-user transmission
+     * \return true if this TX vector is used for a multi-user (OFDMA and/or MU-MIMO) transmission
      */
     bool IsMu() const;
     /**
-     * Return true if this TX vector is used for a downlink multi-user transmission.
-     *
-     * \return true if this TX vector is used for a downlink multi-user transmission
+     * \return true if this TX vector is used for a downlink multi-user (OFDMA and/or MU-MIMO)
+     * transmission
      */
     bool IsDlMu() const;
     /**
-     * Return true if this TX vector is used for an uplink multi-user transmission.
-     *
-     * \return true if this TX vector is used for an uplink multi-user transmission
+     * \return true if this TX vector is used for an uplink multi-user (OFDMA and/or MU-MIMO)
+     * transmission
      */
     bool IsUlMu() const;
     /**
@@ -452,6 +466,17 @@
      */
     ContentChannelAllocation GetContentChannelAllocation() const;
 
+    /**
+     * Set the EHT_PPDU_TYPE parameter
+     * \param type the EHT_PPDU_TYPE parameter
+     */
+    void SetEhtPpduType(uint8_t type);
+    /**
+     * Get the EHT_PPDU_TYPE parameter
+     * \return the EHT_PPDU_TYPE parameter
+     */
+    uint8_t GetEhtPpduType() const;
+
   private:
     /**
      * Derive the RU allocation from the TXVECTOR for which its RU allocation has not been set yet.
@@ -478,6 +503,7 @@
     bool m_ldpc;              /**< LDPC FEC coding if true, BCC otherwise*/
     uint8_t m_bssColor;       /**< BSS color */
     uint16_t m_length;        /**< LENGTH field of the L-SIG */
+    bool m_triggerResponding; /**< The Trigger Responding parameter */
 
     bool m_modeInitialized; /**< Internal initialization flag */
 
@@ -493,6 +519,7 @@
 
     mutable RuAllocation m_ruAllocation; /**< RU allocations that are going to be carried
                                               in SIG-B common field per Table 27-1 IEEE */
+    uint8_t m_ehtPpduType;               /**< EHT_PPDU_TYPE per Table 36-1 IEEE 802.11be D2.3 */
 };
 
 /**
@@ -501,7 +528,7 @@
  * \param os the output stream
  * \param v the WifiTxVector to stringify
  *
- * \return ouput stream
+ * \return output stream
  */
 std::ostream& operator<<(std::ostream& os, const WifiTxVector& v);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-utils.cc ns-3.38/src/wifi/model/wifi-utils.cc
--- ns-3.37/src/wifi/model/wifi-utils.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-utils.cc	2023-03-16 20:54:23.868869300 -0700
@@ -88,7 +88,7 @@
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_TRIGGER);
     CtrlTriggerHeader trigger;
-    trigger.SetType(MU_BAR_TRIGGER);
+    trigger.SetType(TriggerFrameType::MU_BAR_TRIGGER);
     for (auto& t : types)
     {
         auto userInfo = trigger.AddUserInfoField();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/yans-error-rate-model.cc ns-3.38/src/wifi/model/yans-error-rate-model.cc
--- ns-3.37/src/wifi/model/yans-error-rate-model.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/yans-error-rate-model.cc	2023-03-16 20:54:23.868869300 -0700
@@ -385,7 +385,7 @@
                 return GetFecQamBer(snr,
                                     nbits,
                                     txVector.GetChannelWidth() * 1000000, // signal spread
-                                    mode.GetPhyRate(txVector),            // PHY rate
+                                    phyRate,                              // PHY rate
                                     4096,                                 // m
                                     4,                                    // dFree
                                     14,                                   // adFree
@@ -397,7 +397,7 @@
                 return GetFecQamBer(snr,
                                     nbits,
                                     txVector.GetChannelWidth() * 1000000, // signal spread
-                                    mode.GetPhyRate(txVector),            // PHY rate
+                                    phyRate,                              // PHY rate
                                     4096,                                 // m
                                     5,                                    // dFree
                                     8,                                    // adFree
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/yans-wifi-phy.cc ns-3.38/src/wifi/model/yans-wifi-phy.cc
--- ns-3.37/src/wifi/model/yans-wifi-phy.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/yans-wifi-phy.cc	2023-03-16 20:54:23.868869300 -0700
@@ -87,11 +87,11 @@
 }
 
 void
-YansWifiPhy::StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector)
+YansWifiPhy::StartTx(Ptr<const WifiPpdu> ppdu)
 {
     NS_LOG_FUNCTION(this << ppdu);
     NS_LOG_DEBUG("Start transmission: signal power before antenna gain="
-                 << GetPowerDbm(txVector.GetTxPowerLevel()) << "dBm");
+                 << GetPowerDbm(ppdu->GetTxVector().GetTxPowerLevel()) << "dBm");
     m_channel->Send(this, ppdu, GetTxPowerForTransmission(ppdu) + GetTxGain());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/yans-wifi-phy.h ns-3.38/src/wifi/model/yans-wifi-phy.h
--- ns-3.37/src/wifi/model/yans-wifi-phy.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/yans-wifi-phy.h	2023-03-16 20:54:23.868869300 -0700
@@ -57,7 +57,7 @@
     ~YansWifiPhy() override;
 
     void SetInterferenceHelper(const Ptr<InterferenceHelper> helper) override;
-    void StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector) override;
+    void StartTx(Ptr<const WifiPpdu> ppdu) override;
     Ptr<Channel> GetChannel() const override;
     uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const override;
     std::tuple<double, double, double> GetTxMaskRejectionParams() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/channel-access-manager-test.cc ns-3.38/src/wifi/test/channel-access-manager-test.cc
--- ns-3.37/src/wifi/test/channel-access-manager-test.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/test/channel-access-manager-test.cc	2023-03-16 20:54:23.868869300 -0700
@@ -367,11 +367,11 @@
      * \param ackDelay the delay of the Ack after txEnd
      * \param from the index of the requesting Txop
      */
-    void AddAccessRequestWithSuccessfullAck(uint64_t at,
-                                            uint64_t txTime,
-                                            uint64_t expectedGrantTime,
-                                            uint32_t ackDelay,
-                                            uint32_t from);
+    void AddAccessRequestWithSuccessfulAck(uint64_t at,
+                                           uint64_t txTime,
+                                           uint64_t expectedGrantTime,
+                                           uint32_t ackDelay,
+                                           uint32_t from);
     /**
      * Add access request with successful Ack
      * \param txTime the transmit time
@@ -759,7 +759,7 @@
                                                      uint64_t expectedGrantTime,
                                                      uint32_t from)
 {
-    AddAccessRequestWithSuccessfullAck(at, txTime, expectedGrantTime, 0, from);
+    AddAccessRequestWithSuccessfulAck(at, txTime, expectedGrantTime, 0, from);
 }
 
 template <typename TxopType>
@@ -779,11 +779,11 @@
 
 template <typename TxopType>
 void
-ChannelAccessManagerTest<TxopType>::AddAccessRequestWithSuccessfullAck(uint64_t at,
-                                                                       uint64_t txTime,
-                                                                       uint64_t expectedGrantTime,
-                                                                       uint32_t ackDelay,
-                                                                       uint32_t from)
+ChannelAccessManagerTest<TxopType>::AddAccessRequestWithSuccessfulAck(uint64_t at,
+                                                                      uint64_t txTime,
+                                                                      uint64_t expectedGrantTime,
+                                                                      uint32_t ackDelay,
+                                                                      uint32_t from)
 {
     NS_ASSERT(ackDelay < m_ackTimeoutValue);
     Simulator::Schedule(MicroSeconds(at) - Now(),
@@ -1043,7 +1043,7 @@
     StartTest(4, 6, 10);
     AddTxop(0); // high priority DCF
     AddTxop(2); // low priority DCF
-    AddAccessRequestWithSuccessfullAck(20, 20, 34, 2, 1);
+    AddAccessRequestWithSuccessfulAck(20, 20, 34, 2, 1);
     AddAccessRequest(55, 10, 62, 0);
     EndTest();
 
@@ -1381,7 +1381,7 @@
                         m_cam,
                         ccaBusyDuration,
                         busyChannel,
-                        std::vector<Time>(chWidth / 20, Seconds(0)));
+                        std::vector<Time>(chWidth == 20 ? 0 : chWidth / 20, Seconds(0)));
 
     // During any interval ending within CCA_BUSY period, the idle channel is the
     // primary channel contiguous to the busy secondary channel, if the busy channel
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/examples-to-run.py ns-3.38/src/wifi/test/examples-to-run.py
--- ns-3.37/src/wifi/test/examples-to-run.py	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/test/examples-to-run.py	2023-03-16 20:54:23.872869300 -0700
@@ -463,11 +463,11 @@
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11ax-6GHz --serverChannelWidth=160 --clientChannelWidth=160 --serverShortGuardInterval=800 --clientShortGuardInterval=800 --serverNss=4 --clientNss=4 --stepTime=0.1", "False", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11ax-6GHz --serverChannelWidth=160 --clientChannelWidth=160 --serverShortGuardInterval=1600 --clientShortGuardInterval=1600 --serverNss=4 --clientNss=4 --stepTime=0.1", "True", "False"),
     ("wifi-manager-example --wifiManager=MinstrelHt --standard=802.11ax-6GHz --serverChannelWidth=160 --clientChannelWidth=160 --serverShortGuardInterval=3200 --clientShortGuardInterval=3200 --serverNss=4 --clientNss=4 --stepTime=0.1", "True", "False"),
-    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=17 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=20 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=27 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=0", "True", "True"),
-    ("wifi-test-interference-helper --enableCapture=1 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessfull=0 --expectRxBSuccessfull=1", "True", "False"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessful=0 --expectRxBSuccessful=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=17 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessful=0 --expectRxBSuccessful=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=20 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessful=0 --expectRxBSuccessful=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=0 --txPowerA=5 --txPowerB=15  --delay=27 --standard=WIFI_PHY_STANDARD_80211ac --preamble=WIFI_PREAMBLE_VHT_SU --txModeA=VhtMcs0 --txModeB=VhtMcs0 --checkResults=1 --expectRxASuccessful=0 --expectRxBSuccessful=0", "True", "True"),
+    ("wifi-test-interference-helper --enableCapture=1 --txPowerA=5 --txPowerB=15 --delay=10 --txModeA=OfdmRate6Mbps --txModeB=OfdmRate6Mbps --checkResults=1 --expectRxASuccessful=0 --expectRxBSuccessful=1", "True", "False"),
     ("wifi-bianchi --validate --phyMode=OfdmRate54Mbps --nMinStas=5 --nMaxStas=10 --duration=5", "False", "False"), # TODO: run from N=5 to N=50 for 100s (TAKES_FOREVER) when issue #170 is fixed
     ("wifi-bianchi --validate --phyMode=OfdmRate6Mbps --nMinStas=5 --nMaxStas=10 --duration=15", "True", "False"), # TODO: run from N=5 to N=50 for 400s (TAKES_FOREVER) when issue #170 is fixed
     ("wifi-bianchi --validate --phyMode=OfdmRate54Mbps --nMinStas=5 --nMaxStas=10 --duration=5 --infra", "False", "False"), # TODO: run from N=5 to N=50 for 100s (TAKES_FOREVER) when issue #170 is fixed
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.37/src/wifi/test/spectrum-wifi-phy-test.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/test/spectrum-wifi-phy-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -147,6 +147,7 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
+    txParams->txWidth = CHANNEL_WIDTH;
 
     return txParams;
 }
